#include <stdio.h>
#include <stdlib.h>
#include "stdafx.h"

#include "printer.h"

HANDLE Ir_hIDComDev;
HANDLE Bt_hIDComDev;

BOOL Ir_opened=FALSE;
BOOL Bt_opened=FALSE;

LPSTR Format=new char[16];

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved){
    return TRUE;
}

size_t GetT2AStringByteCount(LPCTSTR lpszInput){
 return WideCharToMultiByte(CP_ACP,
						   WC_COMPOSITECHECK|WC_SEPCHARS,
						   lpszInput,         
						   -1,      
						   0,          
						   0,        
						   0,         
						   0          
   );
}

void T2AString(LPCTSTR lpszInput,LPSTR lpszOutput){
 int nCharNum=GetT2AStringByteCount(lpszInput);
 WideCharToMultiByte(
					  CP_ACP,
					  WC_COMPOSITECHECK|WC_DEFAULTCHAR,
					  (LPCWSTR)lpszInput,
					  -1,
					  lpszOutput,
					  nCharNum,
					  0,

					  0);
}

EXPORT BOOL _stdcall PrintText(LPWSTR data){
	DWORD dwNumByteWritten;
	int nCount= GetT2AStringByteCount(data);
	LPSTR lpszOutput=new char[nCount+1];
	memset(lpszOutput,0,nCount+1);
	T2AString(data,lpszOutput);
	int size=nCount+1;
	if(!WriteFile(Bt_hIDComDev,lpszOutput,size,&dwNumByteWritten,NULL))
	{
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't Send Data to Printer!"),TEXT("Error"),MB_OK);
		return FALSE;
	}
	return TRUE;
}


EXPORT BOOL _stdcall PortClose(){
	CloseHandle (Bt_hIDComDev);
	Bt_opened=FALSE;
	return( TRUE );  
}

void PrintError(LPCTSTR str, UINT nType, LPCTSTR pTitle){
	LPVOID lpMsgBuf;
	int error = GetLastError();
	FormatMessage
		(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		error,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf,
		0,
		NULL
		);
	LPTSTR msg = (LPTSTR)lpMsgBuf;
	MessageBox(NULL, msg, pTitle, MB_OK | nType);
	LocalFree(lpMsgBuf);
}


EXPORT BOOL _stdcall PortOpen(int nPort){        
	if(Bt_opened)
		return TRUE;
	else{
		TCHAR szPort[15];
		DCB dcb;
		int nBaud=115200;
		if (nPort < 10) 
			wsprintf( szPort, _T("COM%d:"), nPort );
		else
			wsprintf( szPort, _T("\\\\.\\COM%d"), nPort );

		Bt_hIDComDev = CreateFile( (LPCTSTR)szPort,
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			0,
			NULL 
			);

		if( Bt_hIDComDev == INVALID_HANDLE_VALUE){
			DWORD dwError=GetLastError();
			PrintError(szPort, MB_OK, szPort);
			return( FALSE );
		}

		// Change the CommTimeOuts structure settings.
		COMMTIMEOUTS CommTimeOuts;
		GetCommTimeouts (szPort, &CommTimeOuts);

		CommTimeOuts.ReadIntervalTimeout = MAXDWORD;  
		CommTimeOuts.ReadTotalTimeoutMultiplier = 0;  
		CommTimeOuts.ReadTotalTimeoutConstant = 0;    
		CommTimeOuts.WriteTotalTimeoutMultiplier = 0;  
		CommTimeOuts.WriteTotalTimeoutConstant = 0;    

		if(!SetCommTimeouts( Bt_hIDComDev, &CommTimeOuts ))	{
			DWORD dwError=GetLastError();
			PrintError(szPort, MB_OK, szPort);
			return FALSE;
		}

		dcb.DCBlength = sizeof( DCB );
		GetCommState( Bt_hIDComDev, &dcb );
		dcb.BaudRate = nBaud;

		dcb.fBinary = TRUE;               // Binary mode; no EOF check 
		dcb.fParity = TRUE;               // Enable parity checking 
		dcb.fOutxCtsFlow = FALSE;         // No CTS output flow control 
		dcb.fOutxDsrFlow = FALSE;         // No DSR output flow control 
		dcb.fDtrControl = DTR_CONTROL_ENABLE; 
		// DTR flow control type 
		dcb.fDsrSensitivity = FALSE;      // DSR sensitivity 
		dcb.fTXContinueOnXoff = TRUE;     // XOFF continues Tx 
		dcb.fOutX = FALSE;                // No XON/XOFF out flow control 
		dcb.fInX = TRUE;                 // No XON/XOFF in flow control 
		dcb.fErrorChar = FALSE;           // Disable error replacement 
		dcb.fNull = FALSE;                // Disable null stripping 
		dcb.fRtsControl = RTS_CONTROL_ENABLE; 
		// RTS flow control 
		dcb.fAbortOnError = FALSE;        // Do not abort reads/writes on 
		// error
		dcb.ByteSize = 8;                 // Number of bits/byte, 4-8 
		dcb.Parity = 2;					  // 0-4=no,odd,even,mark,space 
		dcb.StopBits = ONESTOPBIT;        // 0,1,2 = 1, 1.5, 2 


		if( !SetCommState(Bt_hIDComDev, &dcb )||
			!SetupComm(Bt_hIDComDev, 1024, 1024 )/*||
												 m_OverlappedRead.hEvent == NULL ||
												 m_OverlappedWrite.hEvent == NULL*/ )
		{
			DWORD dwError = GetLastError();
			CloseHandle(Bt_hIDComDev );
			PrintError(szPort, MB_OK, szPort);
			return( FALSE );
		} else {
			Bt_opened=TRUE;
		}		
		return(TRUE );
	}
} 

EXPORT BOOL _stdcall SetFont(int width,int Height,int Underline,int direction,int White){
	DWORD dwNumByteWritten;

	Format[0]=0;
	Format[1]=27;
	Format[4]=27;
	Format[7]=27;
	Format[10]=27;
	Format[13]=27;

	Format[2]=85;
	Format[5]=86;
	Format[8]=45;
	Format[11]=99;
	Format[14]=105;

	Format[3]=width;
	Format[6]=Height;
	Format[9]=Underline;
	Format[12]=direction;
	Format[15]=White;

	if(!WriteFile(Bt_hIDComDev,Format,16,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't Send Data to Printer!"),TEXT("Error"),MB_OK);
		return FALSE;
	}
	return TRUE;
}


EXPORT int _stdcall ReadData(LPWSTR data){
	char Byte;
	DWORD dwCommModemStatus,dwBytesTransferred;
	int len = 0;

	if(Ir_hIDComDev){

		SetCommMask (Ir_hIDComDev, EV_RXCHAR | EV_CTS | EV_DSR | EV_RLSD );

		if (Ir_hIDComDev!= INVALID_HANDLE_VALUE){
			WaitCommEvent (Ir_hIDComDev, &dwCommModemStatus, 0);


			SetCommMask (Ir_hIDComDev, EV_RXCHAR | EV_CTS | EV_DSR );

			if (dwCommModemStatus & EV_RXCHAR){
				// Loop for waiting for the data.
				do 	{
					// Read the data from the serial port.
					ReadFile (Ir_hIDComDev,
						&Byte, 
						1, 
						&dwBytesTransferred,
						0
						);

					// Display the data read.
					if (dwBytesTransferred == 1)
					{
						data[len] = Byte;
						data[len+1] = 0;
						len++;
					}
				}
				while (dwBytesTransferred == 1);
			}   
		}
	}
	else if(Bt_hIDComDev)
	{
		SetCommMask (Bt_hIDComDev, EV_RXCHAR | EV_CTS | EV_DSR | EV_RLSD );

		if (Bt_hIDComDev!= INVALID_HANDLE_VALUE) 
		{
			WaitCommEvent (Bt_hIDComDev, &dwCommModemStatus, 0);
			SetCommMask (Bt_hIDComDev, EV_RXCHAR | EV_CTS | EV_DSR );
			if (dwCommModemStatus & EV_RXCHAR) 
			{
				// Loop for waiting for the data.
				do 
				{
					// Read the data from the serial port.
					ReadFile (Bt_hIDComDev,
						&Byte, 
						1, 
						&dwBytesTransferred,
						0
						);

					// Display the data read.
					if (dwBytesTransferred == 1)
					{
						data[len] = Byte;
						data[len+1] = 0;
						len++;
					}
				}
				while (dwBytesTransferred == 1);
			}   
		}
	}
	return len;
}

////////////////////////////////////////////////////////////////////////////////////////

BOOL SendSByte(unsigned char byteToWrite) {
	DWORD dwWritten;
	if(WriteFile(Bt_hIDComDev, &byteToWrite, sizeof(byteToWrite), &dwWritten, 0)) {
		//printf("wrote byte %Xh (%c) to serial port\n", byteToWrite,byteToWrite);
		return TRUE;
	} else {
		//printf("serial port write failed\n");
		return FALSE;
	}
}

unsigned char ReadFByte(HANDLE hFile) {
	DWORD dwRead;
	unsigned char lpBuf;
	ReadFile(hFile,				// handle of file to read
		&lpBuf,					// address of buffer that receives data
		sizeof(lpBuf),			// number of bytes to read
		&dwRead,					// address of number of bytes read
		0);						// address of structure for data
	printf("Read byte %Xh from ifile\n",lpBuf);
	return lpBuf;
}


BOOL SetAddr(INT baseAddr) {
	int i;
	SendSByte('a');
	for (i=0;i<8;i++) {
		SendSByte('0');
	}
	return 1;
}

/*
EXPORT BOOL _stdcall PrintImage(LPWSTR fileName){	
	//  Image file handle
	HANDLE hFile;

	hFile = CreateFile(fileName,					// pointer to name of the file 
	                 GENERIC_READ | GENERIC_WRITE,	// access (read-write) mode 
	                 0,								// share mode 
	                 0,								// pointer to security attributes 
	                 CREATE_ALWAYS,					// how to create
	                 0,								// file attributes
	                 0);							// handle to file with attributes to copy 
 

	if (hFile == INVALID_HANDLE_VALUE) {
	   MessageBox(NULL,TEXT("Failed to open image file!"),TEXT("Error"),MB_OK);
	   return FALSE ;
	} 

	int i;
	int fileSize = 100;
	int startAddr = 0;

	SetAddr(startAddr);
	for (i=0;i<fileSize;i++) {
		SendSByte('w');
		SendSByte(ReadFByte(hFile));			
	}
	if (!CloseHandle( hFile )) {
		 MessageBox(NULL,TEXT("File close failure!"),TEXT("Error"),MB_OK);
	}
	return TRUE;
}
*/

//////////////////////////////////////////////////////////////////////////////////

unsigned long GetFileSize(char *file_name)
{
	FILE *data_file;
	unsigned long size = 0;
	size_t bytes_read;
	char byte_read;

	/* Open the file */
	data_file = fopen(file_name, "rb");

	/* Quit if file couldn't be opened */
	if (data_file == NULL)
	{
		MessageBox(NULL,TEXT("Failed to open image file!"),TEXT("Error"),MB_OK);
		exit(0);
	}

	/* Read in data one byte at a time until we reach the end */
	while (1)
	{
		bytes_read = fread((void *)&byte_read, 1, 1, data_file);
		if (bytes_read <= 0)
		{
			break;
		}
		++size;
	}

	/* Close file */
	fclose(data_file);

	return size;
}

void WriteFileToPort(HANDLE h, char *file_name, unsigned long file_size)
{
	FILE *data_file;
	unsigned long bytes_left = file_size;
	unsigned long bytes_sent;
	unsigned long bytes_read;
	unsigned long total_bytes_sent = 0;
	size_t bytes_to_send;
	char buffer[200];

	/* Open the file */
	data_file = fopen(file_name, "rb");

	/* Quit if file couldn't be opened */
	if (data_file == NULL)
	{
		MessageBox(NULL,TEXT("Failed to open file!"),TEXT("Error"),MB_OK);	
		exit(0);
	}

	while (1)
	{
		/* Determine how many bytes to send */
		if (bytes_left == 0)
		{
			break;
		}
		else if (bytes_left < 200)
		{
			bytes_to_send = bytes_left;
		}
		else
		{
			bytes_to_send = 200;
		}

		/* Read in specified number of bytes */
		bytes_read = (unsigned long)fread((void *)buffer, 1, bytes_to_send, data_file);

		/* Send data over serial cable */
		WriteFile(h, (void *)buffer, bytes_read, &bytes_sent, NULL);
		if (bytes_sent != bytes_read)
		{
			MessageBox(NULL,TEXT("Error writing file!"),TEXT("Error"),MB_OK);	
			CloseHandle(h);
			exit(0);
		}
		
		/* Decrement number of bytes left */
		bytes_left -= bytes_sent;

		/* Increment number of bytes sent */
		total_bytes_sent += bytes_sent;

	}

	fclose(data_file);

	return;
}


EXPORT BOOL _stdcall PrintImage(int serialNo){
	
	DWORD dwNumByteWritten;	
	LPSTR Format=new char[7];
	Format[0]=0;
	Format[1]=27;
	Format[2]=33;	
	memset(&Format[3], 0, sizeof(byte));
	Format[4]=28;
	Format[5]=80;	
	Format[6]=0;	

	if(!WriteFile(Bt_hIDComDev,Format,7,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't print image!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	Format[6]=serialNo;
	if(!WriteFile(Bt_hIDComDev,Format,7,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't print image!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	delete Format;
	PrintText(_T("\n"));
	return TRUE;

}

EXPORT BOOL _stdcall PrintImage1(int mode, LPWSTR fileName) {

	DWORD dwNumByteWritten;	
	LPSTR Format=new char[6];
	Format[0]=0;
	Format[1]=27;
	Format[2]=42;	
	Format[3]=mode;	
	Format[4]=255;	
	Format[5]=3;	
	
	if(!WriteFile(Bt_hIDComDev,Format,6,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't print image!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}

	int nSize = wcslen(fileName);
	char *pAnsiString = new char[nSize+1]; 
	wcstombs(pAnsiString, fileName, nSize+1);
	unsigned long file_size = GetFileSize(pAnsiString);	
	unsigned long file_name_size = (unsigned long)strlen(pAnsiString);
	unsigned long bytes_written;	
		
	WriteFileToPort(Bt_hIDComDev, pAnsiString, file_size);

	PrintText(_T("\n"));
	delete Format;
	return TRUE;

}

EXPORT BOOL _stdcall SetImageMode(int mode, int n1, int n2, int data) {
	DWORD dwNumByteWritten;	
	LPSTR Format=new char[7];
	Format[0]=0;
	Format[1]=27;
	Format[2]=42;	
	Format[3]=mode;	
	Format[4]=n1;	
	Format[5]=n2;	
	Format[6]=data;	

	if(!WriteFile(Bt_hIDComDev,Format,7,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't set image mode!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	PrintText(_T("\n"));
	delete Format;
	return TRUE;
}

EXPORT BOOL _stdcall SetBarcodeMode(int mode, int height, int width) {
	DWORD dwNumByteWritten;	
	LPSTR Format=new char[4];
	Format[0]=0;
	Format[1]=29;
	Format[2]=72;	
	Format[3]=mode;	

	if(!WriteFile(Bt_hIDComDev,Format,4,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't set barcode mode!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}

	Format[0]=0;
	Format[1]=29;
	Format[2]=104;	
	Format[3]=height;	

	if(!WriteFile(Bt_hIDComDev,Format,4,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't set barcode mode!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	
	Format[0]=0;
	Format[1]=29;
	Format[2]=119;	
	Format[3]=width;	

	if(!WriteFile(Bt_hIDComDev,Format,4,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't set barcode mode!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}

	PrintText(_T("\n"));
	delete Format;
	return TRUE;
}

EXPORT BOOL _stdcall SetTextMode(){
	DWORD dwNumByteWritten;	
	LPSTR Format=new char[4];
	Format[0]=0;
	Format[1]=27;
	Format[2]=33;	
	Format[3]=0;	

	if(!WriteFile(Bt_hIDComDev,Format,4,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't set text mode!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	delete Format;
	return TRUE;
}
EXPORT BOOL _stdcall Initialize() {
	DWORD dwNumByteWritten;	
	LPSTR Format=new char[3];
	Format[0]=0;
	Format[1]=27;
	Format[2]=64;	

	if(!WriteFile(Bt_hIDComDev,Format,3,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't initialize!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	delete Format;
	return TRUE;
}

/*
EXPORT BOOL _stdcall PrintImage(LPWSTR fileName){	
	int nSize = wcslen(fileName);
	char *pAnsiString = new char[nSize+1]; 
	wcstombs(pAnsiString, fileName, nSize+1);
	unsigned long file_size = GetFileSize(pAnsiString);	
	unsigned long file_name_size = (unsigned long)strlen(pAnsiString);
	unsigned long bytes_written;	

	WriteFile(Bt_hIDComDev, (void *)&file_name_size, sizeof(unsigned long), &bytes_written, NULL);
	if (bytes_written != sizeof(unsigned long))
	{
		MessageBox(NULL,TEXT("Error writing file name size."),TEXT("Error"),MB_OK);	
		return FALSE;
	}
	
	WriteFile(Bt_hIDComDev, (void *)pAnsiString, file_name_size, &bytes_written, NULL);
	if (bytes_written != file_name_size)
	{
		MessageBox(NULL,TEXT("Error writing file name."),TEXT("Error"),MB_OK);	
		return FALSE;
	}

	WriteFile(Bt_hIDComDev, (void *)&file_size, sizeof(unsigned long), &bytes_written, NULL);
	if (bytes_written != sizeof(unsigned long))
	{
		MessageBox(NULL,TEXT("Error writing file size."),TEXT("Error"),MB_OK);	
		return FALSE;
	}
	
	WriteFileToPort(Bt_hIDComDev, pAnsiString, file_size);

}
*/

void ConvertTToC(CHAR* pszDest, const TCHAR* pszSrc)
{
	for(int i = 0; i < _tcslen(pszSrc); i++)
		pszDest[i] = (CHAR) pszSrc[i];
}

void ConvertCToT(TCHAR* pszDest, const CHAR* pszSrc)
{
	for(int i = 0; i < strlen(pszSrc); i++)
		pszDest[i] = (TCHAR) pszSrc[i];
}

EXPORT BOOL _stdcall PrintBarcode(int n, LPWSTR data){
	DWORD dwNumByteWritten;	
	LPSTR Format ;
		
	if (n != 2 && n != 3) {
		MessageBox(NULL,TEXT("Type must be 2 or 3!"),TEXT("Error"),MB_OK);
		return FALSE;
	}

	Format = new char[4];
	Format[0]=0;
	Format[1]=29;
	Format[2]=107;	
	Format[3]=n;
	if(!WriteFile(Bt_hIDComDev,Format,4,&dwNumByteWritten,NULL)){
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't print bar code!"),TEXT("Error"),MB_OK);
		delete Format;
		return FALSE;
	}
	int nSize = wcslen(data);
	/*
	if (n == 2 && nSize != 13){
		MessageBox(NULL,TEXT("Barcode size must be 13!"),TEXT("Error"),MB_OK);	
		return FALSE;
	}
	if (n == 3 && nSize != 8){
		MessageBox(NULL,TEXT("Barcode size must be 8!"),TEXT("Error"),MB_OK);		
	}
	*/
	/*
	char buf[10];
	wchar_t wa [10];
	sprintf(buf, "%d", nSize);
	mbstowcs(wa, buf,10);
	MessageBox(NULL, (LPCWSTR)wa,TEXT("Error"),MB_OK);
    */
	/*
	nSize = strlen(data);
	sprintf(msg, "%s", nSize);
	MessageBox(NULL,LPWSTR(msg),TEXT("Error"),MB_OK);
	*/
	//char *pAnsiString = new char[nSize+1]; 
	//wcstombs(pAnsiString, data, nSize);
	//pAnsiString[nSize+1]='\0';
	//PrintText(pAnsiString);
	CHAR barcode[255];
	ConvertTToC(barcode, data);
	if(!WriteFile(Bt_hIDComDev,barcode,nSize,&dwNumByteWritten,NULL))
	{
		DWORD dwError = GetLastError();
		MessageBox(NULL,TEXT("Can't print barcode!"),TEXT("Error"),MB_OK);
		return FALSE;
	}
	PrintText(_T("\n"));	
	delete Format;
	return TRUE;	
}